Guile: Add initialization script.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
5umask 002
6
4aa875e9 7sub=
f617db13
MW
8mkdir -p $HOME$sub
9
8ba15f37 10: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
11
12export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
13
14### Sort out command line
15xstuff= false=
16while [ $# -gt 0 ]; do
17 case "$1" in
18 -x) xstuff=t;;
19 -n) false=false;;
20 --) shift; break;;
21 -*) echo >&2 "$0: bad option"; exit 1;;
22 *) break;;
23 esac
24 shift
25done
26
27### Find out where I am
28here=$(pwd)
f617db13
MW
29
30### Suss out how to print things
31out=$(echo -n "foo"; echo "bar")
32if [ "$out" = "foobar" ]; then
33 echon="echo -n"
34 echoc=""
35else
36 echon="echo"
37 echoc='\c'
38fi
39
40### Create the necessary directories
41echo "Creating directories..."
42for i in bin lib/emacs src; do
43 $echon " $i:$echoc"
44 if [ -d $HOME$sub/$i ]; then
45 echo " already exists."
46 else
47 mkdir -p $HOME$sub/$i
48 echo " done."
49 fi
50done
852cd5fb 51echo " all done."
f617db13
MW
52
53### Find out how to fetch things over the net
54$echon "Finding URL fetcher:$echoc"
55if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
56 GETURL="curl -fs -o"
57 echo " curl."
58elif wget >/dev/null 2>&1 --version; then
59 GETURL="wget -q -O"
60 echo " wget."
61else
62 echo " failed!"
63 echo >&2 "$0: failed to find URL fetcher"
64 exit 1
65fi
66
67### Install necessary things
68echo "Installing useful scripts..."
69
af58d83c 70scripts="
370d4c8d 71 lesspipe.sh start-ssh-agent svnwrap movemail-hack"
af58d83c
MW
72[ "$xstuff" ] && scripts="$scripts
73 xrun"
74for script in $scripts; do
f617db13
MW
75 $echon " $script:$echoc"
76 found=
77 for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
78 if $false [ -x $p/$script ]; then
79 found=t
80 break
81 fi
82 done
83 if [ "$found" ]; then
84 echo " already installed."
85 else
86 $echon " downloading$echoc"
87 $GETURL $HOME$sub/bin/$script $REPO/$script
88 chmod +x $HOME$sub/bin/$script
89 echo " done."
90 fi
91done
92
852cd5fb 93echo " all done."
f617db13
MW
94
95### Install some more complicated programs
96echo "Installing packages..."
97systems="
98 mLib:2.0.3:mLib-config
99 chkpath:1.1.0:tmpdir
100"
101[ "$xstuff" ] && systems="$systems
102 mgLib:1.1.0:mgLib-config
103 xtoys:1.3.0:xscsize
104"
105for system in $systems; do
106 set -- $(echo $system | tr : ' ')
107 sys=$1 ver=$2 prog=$3
108 $echon " $sys:$echoc"
109 if $false $prog >/dev/null 2>&1 --version; then
110 echo " already installed."
111 else
112 ( set -e
113 $echon " downloading$echoc"
114 cd $HOME$sub/src
115 rm -rf $sys-$ver.tar.gz $sys-$ver
116 $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
117 $echon " unpacking$echoc"
118 gzip -cd $sys-$ver.tar.gz | tar xf -
119 $echon " configuring$echoc"
120 cd $sys-$ver
121 mkdir build
122 cd build
123 ../configure --prefix=$HOME$sub >>buildlog 2>&1
124 $echon " building$echoc"
125 make >>buildlog 2>&1
126 $echon " installing$echoc"
127 make install >>buildlog 2>&1
128 echo " done."
129 )
130 fi
131done
852cd5fb 132echo " all done."
f617db13 133
f141fe0f
MW
134### Install global configuration
135echo -n "Installing dotfile configuration:"
136if [ -f $HOME$sub/.mdw.conf ]; then
137 echo " already installed."
138else
139 cp mdw.conf $HOME$sub/.mdw.conf
140 echo " done."
141fi
142
f617db13 143### Symlink the various dotfiles into place
852cd5fb 144dotfiles="
be7dba95 145 bash_profile bash_logout bashrc inputrc bash_completion
b3468c3b 146 emacs emacs-calc vm
3e3c03ee 147 vimrc mg
b3468c3b 148 mailrc signature
75d08fb2 149 gitconfig cgrc tigrc
e7d23024 150 gdbinit
8a7e906d 151 guile
ccaac00b
MW
152 lisp-init.lisp:.cmucl-init.lisp
153 lisp-init.lisp:.sbclrc
154 lisp-init.lisp:.clisprc.lisp
f6335a0c 155 lisp-init.lisp:.eclrc
2425eca9 156 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 157[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 158 xinitrc xsession Xdefaults vncrc vncsession
1c6b19d4 159 putty-defaults:.putty/sessions/Default%20Settings
739bccbf 160 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 161 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
eebca092
MW
162 e16-bindings:.e16/bindings.cfg
163 e16-config:.e16/e_config--1.0.cfg
164 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
165 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
f617db13
MW
166echo "Installing dotfiles..."
167for d in $dotfiles; do
739bccbf
MW
168 target=.$d
169 case $d in
170 *:*) target=${d#*:} d=${d%%:*};;
171 esac
172 ft=$HOME$sub/$target
173 dir=${ft%/*}
174 mkdir -p $dir
175 ln -s $here/$d $ft.new
176 mv $ft.new $ft
177 echo " $target"
f617db13 178done
852cd5fb 179echo " all done."
f617db13 180
e04c4857
MW
181### Install useful scripts included in this package
182scripts="
547fb8af
MW
183 mdw-editor
184 emerge-hack"
e04c4857
MW
185echo "Installing scripts..."
186mkdir -p $HOME$sub/bin
187for s in $scripts; do
188 ft=$HOME$sub/bin/$s
189 ln -s $here/$s $ft.new
190 mv $ft.new $ft
191 echo " $s"
192done
193echo " all done."
194
f617db13 195### Set up the Emacs config
65ff0e8c
MW
196$echon "Finding a suitable emacs:$echoc"
197emacs=no
6960aa99 198for i in emacs22 emacs21 emacs; do
65ff0e8c
MW
199 if type -p >/dev/null $i; then
200 emacs=$i
201 break
202 fi
203done
204if [ $emacs = no ]; then
205 echo " failed."
206 emacs=:
207else
208 echo " $emacs."
209fi
210
f617db13 211echo "Installing Emacs packages..."
400223a1
MW
212emacspkg="
213 make-regexp
1778b496 214 git git-blame vc-git stgit
400223a1
MW
215 quilt"
216for elib in $emacspkg; do
f617db13 217 $echon " $elib:$echoc"
65ff0e8c 218 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 219 (progn
852cd5fb
MW
220 (setq load-path (nconc load-path (list "~/lib/emacs")))
221 (kill-emacs (condition-case nil
222 (progn (load-library "'"$elib"'") 0)
20eb0692 223 (error 1))))'; then
f617db13
MW
224 echo " already installed."
225 else
226 $echon " downloading$echoc"
20eb0692 227 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
f617db13
MW
228 $echon " compiling$echoc"
229 (cd $HOME$sub/lib/emacs;
65ff0e8c 230 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 231 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
232 echo " done."
233 fi
234done
852cd5fb 235echo " all done."
f617db13
MW
236
237$echon "Setting up Emacs configuration:$echoc"
238$echon " linking$echoc"
239for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
240 set -- $(echo $link | tr : ' ')
241 from=$1 to=$2
739bccbf
MW
242 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
243 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
244done
245$echon " compiling$echoc"
65ff0e8c 246make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 247echo " done."